<?php

Route::post('/whoops-to-gitlab/postWhoops', function (\Illuminate\Http\Request $request) {
    $data = [
        'data' => $request->get('_data'),
        'title' => mb_substr($request->get('auto_title'), 0, 35) . '... | ' . $request->get('title')
    ];
    $desc = $request->get('description');

    if (config('gitlab.selected_bin') !== null) {
        $bin = new \Dalnix\WhoopsToGitlab\Postbin();
        $pastelink = $bin->sendDataToBin($data);
        $desc = $desc . '<br>Link to pastebin: <a href="' . $pastelink . '">' . $pastelink . '</a>';
    }

    $gitlab_response = \Dalnix\WhoopsToGitlab\Facades\Gitlab::addIssue([
        'title' => $data['title'],
        'description' => $desc,
        'labels' => 'autogenerated'
    ]);

    if ($gitlab_response) {
        return view('whoopsToGitlab::response')->with('response', $gitlab_response);
    }

})->name('whoopsToGitlab.post');
